//Fortran: EQUIVALENCE ( ... )
Unit SF67R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF23C_p, QSF3R_p, SF67R1_p;

procedure SF67R(X10 :Real; R10 :Real; var T10 :Real);

implementation

procedure SF67R(X10 :Real; R10 :Real; var T10 :Real);
var
IERR,J,L,L1,L2,M,N :Integer;
A0,A1,A2,ARGI,ARGR,B0,C0,C1,C2,E,EPS,F0,FI,G0,H0,PI,R0,RINT1,RINT2,S1,
   S2,T,T0,T1,T2,U,V :Real;
A :Array [0..16] of Real;
B :Array [0..16] of Real;
C :Array [0..288] of Integer;
G :Array [0..16] of Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
EPS1 :Real = 1.0E-7;
EPS2 :Real = 1.0E-5;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
PI := SYS001;   //  EQUIVALENCE
_SF67R2.elm1  := X10;
R0  := R10;
if ( _SF67R2.elm1  >=  2.5 ) and (  R0  <=  0.5 ) or (  _SF67R2.elm1  >=  3.5 ) and (
     R0  <=  1.5 ) or (  _SF67R2.elm1  >=  4.5 ) and (  R0  <=  2.0 ) or (  _SF67R2.elm1  >= 
     5.5 ) and (  R0  <=  3.25 ) or (  _SF67R2.elm1  >=  7.0 ) and (  R0  <=  4.2 )
 then goto _60;
if ( _SF67R2.elm1  >=  7.5 ) and (  R0  >=  4.2 ) and (  R0  <=  5.0 ) or ( 
     _SF67R2.elm1  >=  8.5 ) and (  R0  >=  4.2 ) and (  R0  <=  6.0 )
 then goto _110;
{      HAAO BCEH KOMEKCHO AMMA-YHK }
EPS  := EPS1;
L  := 1;
ARGR  := 0.0;
ARGI  := R0;
SF23C(ARGR,ARGI,U,V,EPS,L,IERR);
{      OKOHAHE BCEH KOEKCHO AMMA-YHK }
C0  := V/U;
T2  := ArcTan(C0);
if ( U  >=  0 ) and (  V  >=  0 ) or (  U  >=  0 ) and (  V  <= 
     0 ) 
 then goto _10;
if ( U  <  0 ) and (  V  >=  0 ) 
 then goto _20;
if ( U  <  0 ) and (  V  <  0 ) 
 then goto _30;
_10:
T1  := T2;
goto _40;
_20:
T1  := T2 + PI;
goto _40;
_30:
T1  := T2 - PI;
_40:
T  := R0*Ln(_SF67R2.elm1/2.0) - T1;
C0  := Sqrt(PI/(R0*(Exp(PI*R0) - Exp(-PI*R0))/2.0));
A1  := C0*Cos(T);
A2  := C0*Sin(T);
A0  := R0*IntPower(_SF67R2.elm1/2.0,2)/(1.0+ IntPower(R0,2));
B0  := IntPower(_SF67R2.elm1/2.0,2)/(1.0+ IntPower(R0,2));
T0  := A1*(1.0+ B0) + A2*A0;
for J:=1 to 50 do
 begin
  F0  := IntPower(_SF67R2.elm1/2.0,2)/(IntPower(J + 1,2) + IntPower(R0,2));
  G0  := R0*IntPower(_SF67R2.elm1/2.0,2)/((J + 1)*(IntPower(J + 1,2) + IntPower(R0,2)));
  H0  := A0;
  A0  := A0*F0 + B0*G0;
  B0  := B0*F0 - H0*G0;
  T0  := T0 + A1*B0 + A2*A0;
_50:
 end;
goto _120;
_60:
for N:=2 to 17 do
 begin
  C[0+(N-1)*17] := Trunc(IntPower(-1,N));
  for M:=2 to N do
   begin
    C[(M-1)+(N-1)*17] := -C[(M-2)+(N-1)*17]*2*(N + M - 3)*(N - M + 1) div ((M - 1)*
    (2*(M - 1)));
_70:
   end;
_80:
 end;
C0  := IntPower(R0,2) + 1.0/4.0;
C1  := C0;
A[0] := 1/C0;
B[0] := 1/C0;
G[0] := 1/C0;
for M:=2 to 17 do
 begin
  C2  := C1;
  C1  := C0 + (M - 1)*M;
  G[M-1] := G[M-2]*C2/(C1*_SF67R2.elm1);
  B[M-1] := -2.0*(M - 1)*B[M-2]/C1;
  A[M-1] := -2.0*(M - 1)*A[M-2]/C1 + G[M-1];
_90:
 end;
N  := 17;
F0  := Sqrt(PI/(2.0*_SF67R2.elm1))*Exp(-_SF67R2.elm1);
S1  := 0;
S2  := 0;
for M:=1 to N do
 begin
  S1  := S1 + C[(M-1)+(N-1)*17]*A[M-1];
  S2  := S2 + C[(M-1)+(N-1)*17]*B[M-1];
  T0  := F0*S1/S2;
_100:
 end;
goto _120;
_110:
A[0] := 0.0;
B[0] := 5.0;
FI  := 0.0;
E  := EPS2;
L1  := 0;
L2  := 1;
QSF3R(RINT1,RINT2,A[0],B[0],SF67R1,R0,FI,E,L1,L2);
T0  := RINT2*Exp(-_SF67R2.elm1);
_120:
T10  := T0;
end;

end.
